SystemOrganization addCategory: #'Twitter-Bootstrap-Magritte'!

!MAContainerComponent methodsFor: '*twitter-bootstrap-magritte-decorating' stamp: 'topa 11/22/2012 23:20'!
addTWBSForm
	self addDecoration: (TWBSMagritteFormDecoration newWithDefaultButtons)! !

!MAContainerComponent methodsFor: '*twitter-bootstrap-magritte-decorating' stamp: 'topa 11/22/2012 23:21'!
addTWBSForm: aCollection
	self addDecoration: (TWBSMagritteFormDecoration button: aCollection)! !

!MAContainerComponent methodsFor: '*twitter-bootstrap-magritte-decorating' stamp: 'topa 11/22/2012 23:24'!
addTWBSForm: aCollection customizing: aBlock
	| deco |
	deco := TWBSMagritteFormDecoration button: aCollection.
	aBlock cull: deco.
	self addDecoration: deco.! !

!MAContainerComponent methodsFor: '*twitter-bootstrap-magritte-decorating' stamp: 'topa 11/22/2012 23:23'!
addTWBSFormCustomizing: aBlock
	| deco |
	deco := TWBSMagritteFormDecoration newWithDefaultButtons.
	aBlock cull: deco.
	self addDecoration: deco! !

!MAContainerComponent methodsFor: '*twitter-bootstrap-magritte-decorating' stamp: 'topa 11/22/2012 23:22'!
addTWBSValidation
	self addDecoration: TWBSMagritteValidationDecoration new! !

MAOneToManyComponent subclass: #TWBSMagritteOneToManyComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Magritte'!

!TWBSMagritteOneToManyComponent methodsFor: 'private' stamp: 'topa 11/23/2012 00:18'!
buildReport

	^ (TWBSMagritteReport rows: self value description: self reference)
		sortEnabled: self magritteDescription isOrdered not;
		yourself! !

!TWBSMagritteOneToManyComponent methodsFor: 'as yet unclassified' stamp: 'topa 11/23/2012 10:14'!
renderSelectButtonOn: html
	html button 
		beSubmit;
		class: 'btn';
		callback: [self add];
		with: [html twbsIcon: 'plus'; space; text: (self labelForSelector: #add)]
! !

!MAElementDescription methodsFor: '*twitter-bootstrap-magritte' stamp: 'NickAger 3/10/2012 01:00'!
placeholder
	^ self 
		propertyAt: #placeholder 
		ifAbsent: [ nil ]! !

!MAElementDescription methodsFor: '*twitter-bootstrap-magritte' stamp: 'NickAger 3/10/2012 01:01'!
placeholder: placeHolderText
	^ self propertyAt: #placeholder put: placeHolderText! !

MATextInputComponent subclass: #TWBSMagritteDisabledTextInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Magritte'!

!TWBSMagritteDisabledTextInputComponent methodsFor: 'rendering' stamp: 'topa 11/22/2012 22:52'!
renderInputOn: html
	| textInput |
	textInput := html textInput.
	description placeholder notNil ifTrue: [ 
		textInput twbsPlaceholderText: description placeholder ].
	
	description cssClasses isEmpty ifFalse: [
		textInput class: (String streamContents: [:stream |
			description cssClasses 
				do: [:cls | stream nextPutAll: cls] 
				separatedBy: [stream nextPut: Character space]])].

	textInput
		id: self labelId;
		disabled;
		on: #string of: self. ! !

MATextInputComponent subclass: #TWBSMagritteTextInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Magritte'!

!TWBSMagritteTextInputComponent methodsFor: 'rendering' stamp: 'topa 11/22/2012 22:52'!
renderInputOn: html
	| textInput |
	textInput := html textInput.
	description placeholder notNil ifTrue: [ 
		textInput twbsPlaceholderText: description placeholder ].
	
	description cssClasses isEmpty ifFalse: [
		textInput class: (String streamContents: [:stream |
			description cssClasses 
				do: [:cls | stream nextPutAll: cls] 
				separatedBy: [stream nextPut: Character space]])].
	
	textInput
		id: self labelId;
		on: #string of: self. ! !

MARadioGroupComponent subclass: #TWBSMagritteRadioGroupComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Magritte'!

!TWBSMagritteRadioGroupComponent class methodsFor: 'testing' stamp: 'NickAger 3/20/2012 11:37'!
isAbstract
	^ false! !

!TWBSMagritteRadioGroupComponent methodsFor: 'rendering' stamp: 'NickAger 3/22/2012 10:47'!
renderEditorOn: html
	| group |
	group := html radioGroup.
	html span
		id: self labelId;
		with: [
			self optionsWithIndexDo: [ :each :index |
				self renderOption: each
					index: index
					in: group
					on: html ]
				separatedBy: [ ] ]! !

!TWBSMagritteRadioGroupComponent methodsFor: 'rendering' stamp: 'NickAger 3/22/2012 09:22'!
renderOption: anObject index: anInteger in: aRadioGroup on: html
	| optionId |
	optionId := self optionId: anInteger.
	html label
		class: 'radio';
		with: [
			html radioButton
				id: optionId;
				group: aRadioGroup;
				selected: self value = anObject;
				callback: [ self value: anObject ].
			html space.
			html text: (self labelForOption: anObject) ].


! !

MAReport subclass: #TWBSMagritteReport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Magritte'!

!TWBSMagritteReport methodsFor: 'private-batch' stamp: 'JanVanDeSandt 3/22/2012 17:23'!
batchPageRangeEnd
	^ self batchMaxPages min: self batchPage + 5! !

!TWBSMagritteReport methodsFor: 'private-batch' stamp: 'JanVanDeSandt 3/22/2012 17:23'!
batchPageRangeStart
	^ self defaultBatchPage max: self batchPage - 5! !

!TWBSMagritteReport methodsFor: 'accessing-defaults' stamp: 'JanVanDeSandt 3/29/2012 21:21'!
defaultShowBordered
	^ true! !

!TWBSMagritteReport methodsFor: 'accessing-defaults' stamp: 'JanVanDeSandt 3/29/2012 21:22'!
defaultShowCondensed
	^ false! !

!TWBSMagritteReport methodsFor: 'accessing-defaults' stamp: 'topa 11/22/2012 22:24'!
defaultShowHover
	^ false! !

!TWBSMagritteReport methodsFor: 'accessing-defaults' stamp: 'JanVanDeSandt 3/29/2012 22:05'!
defaultShowStriped
	^ false! !

!TWBSMagritteReport methodsFor: 'rendering-batch' stamp: 'JanVanDeSandt 3/23/2012 14:19'!
renderAnchorItem: aCallback with: aBlock active: aBoolean on: html

	self renderAnchorItem: aCallback with: aBlock disabled: false active: aBoolean on: html ! !

!TWBSMagritteReport methodsFor: 'rendering-batch' stamp: 'topa 11/22/2012 22:44'!
renderAnchorItem: aCallback with: aBlock disabled: aBoolean active: anActiveBoolean on: html

	html listItem
		class: 'active' if: anActiveBoolean ;
		class: 'disabled' if: aBoolean ;
		with: [
			(aBoolean or: [ anActiveBoolean ])
				ifTrue: [
					html anchor
						with: aBlock ]
				ifFalse: [
					html anchor
						callback: aCallback; 
						with: aBlock ] ]! !

!TWBSMagritteReport methodsFor: 'rendering-batch' stamp: 'JanVanDeSandt 3/23/2012 14:18'!
renderAnchorItem: aCallback with: aBlock disabled: aBoolean on: html

	self renderAnchorItem: aCallback with: aBlock disabled: aBoolean active: false on: html ! !

!TWBSMagritteReport methodsFor: 'rendering-batch' stamp: 'JanVanDeSandt 3/23/2012 14:22'!
renderAnchorItemDisabledWith: aString on: html

	self renderAnchorItem: nil with: aString disabled: true on: html! !

!TWBSMagritteReport methodsFor: 'rendering-batch' stamp: 'topa 11/23/2012 12:01'!
renderBatchDivOn: html

	html div
		class: 'pagination' ;
		with: [
			html twbsUnorderedList with: [
				self showBatchFirstLast
					ifTrue: [ self renderBatchFirstOn: html ].
				self showBatchPreviousNext
					ifTrue: [ self renderBatchPreviousOn: html ].
				self showBatchPages
					ifTrue: [ self renderBatchItemsOn: html ].
				self showBatchPreviousNext
					ifTrue: [ self renderBatchNextOn: html ].
				self showBatchFirstLast
					ifTrue: [ self renderBatchLastOn: html ] ] ]! !

!TWBSMagritteReport methodsFor: 'rendering-batch' stamp: 'topa 11/23/2012 10:14'!
renderBatchFirstOn: html

	self renderAnchorItem: [ self batchPage: self defaultBatchPage ] 
		with: [ html twbsIcon: 'fast-backward' ] 
		disabled: self isOnFirstPage 
		on: html! !

!TWBSMagritteReport methodsFor: 'rendering-batch' stamp: 'JanVanDeSandt 4/4/2012 12:22'!
renderBatchItemsOn: html
	self batchPageRangeStart > self defaultBatchPage
		ifTrue: [ self renderAnchorItemDisabledWith: '...' on: html ].
	self batchPageRange do: [ :index |
		
		self renderAnchorItem: [ self batchPage: index ] 
			with: index 
			active: (self batchPage = index)
			on: html ].
	
	self batchPageRangeEnd < (self batchMaxPages - 1)
		ifTrue: [ self renderAnchorItemDisabledWith: '...' on: html ].
		
	(self showBatchFirstLast or: [ self batchPageRangeEnd = self batchMaxPages ])
		ifFalse: [
			self renderAnchorItem: [ self batchPage: self batchMaxPages ] 
				with: self batchMaxPages
				active: false 
				on: html ]! !

!TWBSMagritteReport methodsFor: 'rendering-batch' stamp: 'topa 11/23/2012 10:14'!
renderBatchLastOn: html

	self renderAnchorItem: [ self batchPage: self batchMaxPages ] 
		with: [ html twbsIcon: 'fast-forward' ] 
		disabled: self isOnLastPage 
		on: html! !

!TWBSMagritteReport methodsFor: 'rendering-batch' stamp: 'topa 11/23/2012 10:14'!
renderBatchNextOn: html

	self renderAnchorItem: [ self nextPage ] 
		with: [ html twbsIcon: 'forward' ] 
		disabled: self isOnLastPage 
		on: html! !

!TWBSMagritteReport methodsFor: 'rendering-batch' stamp: 'topa 11/23/2012 10:14'!
renderBatchPreviousOn: html

	self renderAnchorItem: [ self previousPage ] 
		with: [ html twbsIcon: 'backward' ] 
		disabled: self isOnFirstPage 
		on: html! !

!TWBSMagritteReport methodsFor: 'rendering' stamp: 'JanVanDeSandt 3/23/2012 13:56'!
renderContentOn: html
	html table
		id: self ajaxId; 
		class: self tableClass;
		with: [ self renderTableOn: html ]! !

!TWBSMagritteReport methodsFor: 'rendering' stamp: 'JanVanDeSandt 3/22/2012 16:37'!
renderTableBatchOn: html
	self hasMoreThanOnePage ifTrue: [
		html tableRow: [
			html tableData
				class: 'batch';
				colSpan: self visibleColumns size;
				with: [
					self renderBatchDivOn: html ] ] ]! !

!TWBSMagritteReport methodsFor: 'private' stamp: 'JanVanDeSandt 3/29/2012 22:04'!
rowStyleForNumber: aNumber
	"odd/even classes not required for Twitter Bootstrap."
	^ nil! !

!TWBSMagritteReport methodsFor: 'accessing-settings' stamp: 'JanVanDeSandt 3/29/2012 21:24'!
showBordered
	^ properties at: #showBordered ifAbsent: [ self defaultShowBordered ]! !

!TWBSMagritteReport methodsFor: 'accessing-settings' stamp: 'JanVanDeSandt 3/29/2012 21:24'!
showBordered: aBoolean
	properties at: #showBordered put: aBoolean! !

!TWBSMagritteReport methodsFor: 'accessing-settings' stamp: 'JanVanDeSandt 3/29/2012 21:21'!
showCondensed
	^ properties at: #showCondensed ifAbsent: [ self defaultShowCondensed ]! !

!TWBSMagritteReport methodsFor: 'accessing-settings' stamp: 'JanVanDeSandt 3/29/2012 21:22'!
showCondensed: aBoolean
	properties at: #showCondensed put: aBoolean! !

!TWBSMagritteReport methodsFor: 'accessing-settings' stamp: 'topa 11/22/2012 22:24'!
showHover
	^ properties at: #showHover ifAbsent: [ self defaultShowHover ]! !

!TWBSMagritteReport methodsFor: 'accessing-settings' stamp: 'topa 11/22/2012 22:24'!
showHover: aBoolean
	properties at: #showHover put: aBoolean! !

!TWBSMagritteReport methodsFor: 'accessing-settings' stamp: 'JanVanDeSandt 3/29/2012 21:23'!
showStriped
	^ properties at: #showStriped ifAbsent: [ self defaultShowStriped ]! !

!TWBSMagritteReport methodsFor: 'accessing-settings' stamp: 'JanVanDeSandt 3/29/2012 21:24'!
showStriped: aBoolean
	properties at: #showStriped put: aBoolean! !

!TWBSMagritteReport methodsFor: 'accessing' stamp: 'topa 11/22/2012 22:30'!
tableClass

	^ String streamContents: [:stream |
		stream 
			nextPutAll: 'report'; nextPut: Character space;
			nextPutAll: 'table'.				
		self showBordered 
			ifTrue: [stream nextPut: Character space; nextPutAll: 'table-bordered'].
		self showStriped 
			ifTrue: [stream nextPut: Character space; nextPutAll: 'table-striped' ].
		self showCondensed 
			ifTrue: [stream nextPut: Character space; nextPutAll: 'table-condensed' ].
		self showHover 
			ifTrue: [stream nextPut: Character space; nextPutAll: 'table-hover']].
! !

MAValidationDecoration subclass: #TWBSMagritteValidationDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Magritte'!

!TWBSMagritteValidationDecoration methodsFor: 'rendering' stamp: 'NickAger 3/21/2012 18:17'!
renderErrorsOn: html
	html break.
		
	html div
		class: 'alert';
		class: 'alert-error';
		with: [
			html anchor 
				class: 'close';
				attributeAt: 'data-dismiss' put: 'alert';
				with: [ html html: '&#215;' ].

			html strong: 'Please correct the following issues:'.
			html unorderedList
				class: 'errors';
				list: self errors;
				with: nil ]! !

MAComponentRenderer subclass: #TWBSMagritteFormRenderer
	instanceVariableNames: 'validationMessagesInline formInline'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Magritte'!

!TWBSMagritteFormRenderer methodsFor: 'error handling' stamp: 'NickAger 3/9/2012 22:32'!
errorsForDescription: aDescription 
	^ component errors select: [ :anError | anError tag = aDescription ]! !

!TWBSMagritteFormRenderer methodsFor: 'accessing' stamp: 'NickAger 3/22/2012 11:07'!
formInline
	^ formInline ifNil: [ formInline := false ]! !

!TWBSMagritteFormRenderer methodsFor: 'accessing' stamp: 'NickAger 3/22/2012 11:07'!
formInline: anObject
	formInline := anObject! !

!TWBSMagritteFormRenderer methodsFor: 'rendering' stamp: 'NickAger 3/20/2012 13:34'!
renderComment:  aDescription
	aDescription comment notNil ifTrue: [
		html span
			class: 'help-inline';
			with: [
				html html: aDescription comment ] ]! !

!TWBSMagritteFormRenderer methodsFor: 'rendering' stamp: 'NickAger 3/22/2012 11:13'!
renderContainer: aDescription
	self validationMessagesInline: aDescription twbsInlineValidationMessages.
	self formInline: aDescription twbsFormInline.
	self formInline ifTrue: [ html break ].
	
	super renderContainer: aDescription! !

!TWBSMagritteFormRenderer methodsFor: 'rendering' stamp: 'NickAger 3/19/2012 13:40'!
renderControl: aDescription
	html render: (self childAt: aDescription)! !

!TWBSMagritteFormRenderer methodsFor: 'rendering' stamp: 'NickAger 3/29/2012 10:57'!
renderElement: aDescription
	aDescription group = group
		ifFalse: [ self renderGroup: aDescription ].
		
	self formInline 
		ifTrue: [ self renderElementForInlineForm: aDescription ]
		ifFalse: [ 
			html div
				class: 'control-group';
				class: (self classFor: aDescription);
				with: [
					self renderLabel: aDescription.
					html div
						class: 'controls';
						 with: [ 			
							self renderControl: aDescription.
							self renderComment: aDescription.
							self validationMessagesInline ifTrue: [ self renderInlineError: aDescription ] ] ] ]! !

!TWBSMagritteFormRenderer methodsFor: 'rendering' stamp: 'NickAger 3/29/2012 10:57'!
renderElementForInlineForm: aDescription
	html span
		class: 'control-group';
		class: (self classFor: aDescription);
		with: [
			self renderLabel: aDescription.
			html space.
			html span
				class: 'controls';
				 with: [ 			
					self renderControl: aDescription.
					html space.
					self renderComment: aDescription.
					self validationMessagesInline ifTrue: [ self renderInlineError: aDescription ] ].
			html space ]! !

!TWBSMagritteFormRenderer methodsFor: 'rendering' stamp: 'NickAger 3/29/2012 10:57'!
renderInlineError: aDescription
	(self errorsForDescription: aDescription) do: [ :error |
		html div
			class: 'alert';
			class: 'alert-error';
			with: error messageText ]! !

!TWBSMagritteFormRenderer methodsFor: 'rendering' stamp: 'NickAger 3/27/2012 23:50'!
renderLabel: aDescription
	| label |
	aDescription hasLabel ifFalse: [ ^ self ].
	label := html label class: 'control-label'.
	(self childAt: aDescription) hasLabelId
		ifTrue: [ label for: (self childAt: aDescription) labelId ].
	label with: [ html html: aDescription label; text: ':' ]! !

!TWBSMagritteFormRenderer methodsFor: 'accessing' stamp: 'NickAger 3/20/2012 13:30'!
validationMessagesInline
	^ validationMessagesInline ifNil: [ validationMessagesInline := true ]! !

!TWBSMagritteFormRenderer methodsFor: 'accessing' stamp: 'NickAger 3/20/2012 13:30'!
validationMessagesInline: anObject
	validationMessagesInline := anObject! !

MACheckboxGroupComponent subclass: #TWBSMagritteCheckboxGroupComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Magritte'!

!TWBSMagritteCheckboxGroupComponent methodsFor: 'as yet unclassified' stamp: 'topa 11/22/2012 23:47'!
renderEditorOn: html
	html hiddenInput 
		callback: [ :value | self clear ].
	self
		optionsWithIndexDo: [ :each :index |
			| optionId |
			optionId := self optionId: index.
			html label
				class: 'checkbox';
				for: optionId;
				with: [
					html checkbox
						class: 'checkbox';
						id: optionId;
						value: (self selectedList includes: each);
						onTrue: [ self add: each ] 
						onFalse: [ self remove: each ].
					html space.
					html text: (self labelForOption: each)]]
		separatedBy: []! !

MAListCompositonComponent subclass: #TWBSListCompositionComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Magritte'!

!TWBSListCompositionComponent methodsFor: 'as yet unclassified' stamp: 'topa 11/23/2012 00:02'!
renderEditorAvailableOn: html
	html select
		size: 6; 
		style: 'span3';
		list: self availableList;
		selected: self availableSelected;
		callback: [ :value | self availableSelected: value ];
		labels: [ :value | self labelForOption: value ]! !

!TWBSListCompositionComponent methodsFor: 'as yet unclassified' stamp: 'topa 11/23/2012 10:13'!
renderEditorButtonAddOn: html
	html div
		class: 'btn-group';
		class: 'btn-group-vertical';
		with: [
			html button
				beSubmit;
				class: 'btn';
				callback: [ self add ];
				with: [html twbsIcon: 'forward'].
			html button
				class: 'btn';
				beSubmit;
				callback: [ self remove ];
				with: [html twbsIcon: 'backward']].! !

!TWBSListCompositionComponent methodsFor: 'as yet unclassified' stamp: 'topa 11/23/2012 10:14'!
renderEditorButtonOrderOn: html
	html div
		class: 'btn-group';
		class: 'btn-group-vertical';
		with: [
			html button
				beSubmit;
				class: 'btn';
				callback: [ self moveUp ];
				with: [html twbsIcon: 'caret-up'].
			html button
				beSubmit
				class: 'btn';
				callback: [ self moveDown ];
				with: [html twbsIcon: 'caret-down']].! !

!TWBSListCompositionComponent methodsFor: 'rendering' stamp: 'topa 11/23/2012 00:12'!
renderEditorOn: html
	
	html div
		class: 'controls-row';
		with: [	
			self renderEditorAvailableOn: html.
			self renderEditorButtonAddOn: html.
			self renderEditorSelectedOn: html.
			self isOrdered ifTrue: [
				self renderEditorButtonOrderOn: html]]! !

!TWBSListCompositionComponent methodsFor: 'as yet unclassified' stamp: 'topa 11/23/2012 00:04'!
renderEditorSelectedOn: html
	html select
		size: 6; 
		style: 'span3';
		list: self selectedList;
		selected: self selectedSelected;
		callback: [ :value | self selectedSelected: value ];
		labels: [ :value | self labelForOption: value ]! !

!MAContainer methodsFor: '*twitter-bootstrap-magritte' stamp: 'NickAger 3/22/2012 11:00'!
twbsFormInline
	^ self propertyAt: #twbsFormInline ifAbsent: [ false ]! !

!MAContainer methodsFor: '*twitter-bootstrap-magritte' stamp: 'NickAger 3/22/2012 11:01'!
twbsFormInline: aBoolean
	self propertyAt: #twbsFormInline put: aBoolean! !

!MAContainer methodsFor: '*twitter-bootstrap-magritte' stamp: 'NickAger 3/22/2012 10:59'!
twbsInlineValidationMessages
	^ self propertyAt: #twbsInlineValidationMessages ifAbsent: [ true ]! !

!MAContainer methodsFor: '*twitter-bootstrap-magritte' stamp: 'NickAger 3/22/2012 11:00'!
twbsInlineValidationMessages: aBoolean
	self propertyAt: #twbsInlineValidationMessages put: aBoolean! !

MAFormDecoration subclass: #TWBSMagritteFormDecoration
	instanceVariableNames: 'formCss legend'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Magritte'!

!TWBSMagritteFormDecoration class methodsFor: 'instance creation' stamp: 'NickAger 3/19/2012 21:07'!
newWithDefaultButtons
	^ self new 
		addButtons: #(save cancel);
		yourself! !

!TWBSMagritteFormDecoration methodsFor: 'as yet unclassified' stamp: 'topa 11/22/2012 23:28'!
beHorizontal
	formCss := 'form-horizontal'! !

!TWBSMagritteFormDecoration methodsFor: 'as yet unclassified' stamp: 'topa 11/22/2012 23:27'!
beInline
	formCss := 'form-inline'! !

!TWBSMagritteFormDecoration methodsFor: 'relationship' stamp: 'topa 11/22/2012 23:27'!
beSearch
	formCss := 'form-search'! !

!TWBSMagritteFormDecoration methodsFor: 'as yet unclassified' stamp: 'topa 11/22/2012 23:27'!
beVertical
	formCss := 'form-vertical'! !

!TWBSMagritteFormDecoration methodsFor: 'accessing' stamp: 'NickAger 3/19/2012 15:35'!
formCss
	^ formCss! !

!TWBSMagritteFormDecoration methodsFor: 'accessing' stamp: 'NickAger 3/19/2012 15:35'!
formCss: anObject
	formCss := anObject! !

!TWBSMagritteFormDecoration methodsFor: 'as yet unclassified' stamp: 'topa 11/23/2012 00:51'!
initialize

	super initialize.
	self beVertical.! !

!TWBSMagritteFormDecoration methodsFor: 'accessing' stamp: 'NickAger 3/21/2012 17:39'!
legend
	^ legend! !

!TWBSMagritteFormDecoration methodsFor: 'accessing' stamp: 'NickAger 3/21/2012 17:39'!
legend: anObject
	legend := anObject! !

!TWBSMagritteFormDecoration methodsFor: 'rendering' stamp: 'NickAger 3/19/2012 15:43'!
renderButtonsOn: html
	html div 
		class: 'form-actions'; 
		class: self formCss;
		with: [
			self buttons 
				do: [ :each |
					html button
						accessKey: each value first;
						class: 'btn';
						class: 'btn-primary' if: (each = buttons first);
						callback: [ self execute: each key ];
						text: each value ]
				separatedBy: [ html text: ' ' ] ]! !

!TWBSMagritteFormDecoration methodsFor: 'rendering' stamp: 'NickAger 3/21/2012 17:40'!
renderContentOn: html
	html form
		class: 'magritte';
		class: self formCss;
		multipart: self requiresMultipartForm;
		defaultAction: [ self execute: self default ];
		with: [
			html fieldSet: [
				self renderLegendOn: html.
				self renderNextOn: html.
				self renderButtonsOn: html ] ]! !

!TWBSMagritteFormDecoration methodsFor: 'rendering' stamp: 'NickAger 3/21/2012 17:41'!
renderLegendOn: html
	self legend notNil ifTrue: [
		html legend: self legend ]! !

MACheckboxComponent subclass: #TWBSMagritteCheckboxComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Magritte'!

!TWBSMagritteCheckboxComponent methodsFor: 'rendering' stamp: 'NickAger 3/22/2012 09:21'!
renderEditorOn: html
	html label
		class: 'checkbox';
		with: [
			html checkbox
				id: self labelId;
				disabled: self isReadonly;
				on: #value of: self.
			html space; render: self magritteDescription checkboxLabel ]! !

MAVerifiedPasswordComponent subclass: #TWBSVerifiedPasswordComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Magritte'!

!TWBSVerifiedPasswordComponent methodsFor: 'rendering' stamp: 'NickAger 3/29/2012 13:27'!
renderEditorOn: html
	| passwordInput verifiedPasswordInput |
	passwordInput := html passwordInput.
	description placeholder notNil ifTrue: [ 
		passwordInput twbsPlaceholderText: description placeholder ].
	passwordInput
		id: self labelId;
		on: #string of: self.
		
	html break.
	
	verifiedPasswordInput := html passwordInput.
	
	description placeholder notNil ifTrue: [ 
		verifiedPasswordInput twbsPlaceholderText: 'verify password' ].
	
	verifiedPasswordInput
		class: 'verification';
		on: #verificationString of: self! !

!TWBSVerifiedPasswordComponent methodsFor: 'as yet unclassified' stamp: 'NickAger 3/29/2012 13:25'!
renderInputOn: html
	| textInput |
	textInput := html textInput.
	description placeholder notNil ifTrue: [ 
		textInput twbsPlaceholderText: description placeholder ].	
		
	textInput
		id: self labelId;
		on: #string of: self.! !
